﻿using Newtonsoft.Json;
using System;
using System.ComponentModel;
using System.Data;
using WSCF;

namespace RemoteSQLite
{
    public interface ISQLiteRemoteService
    {

        
        /// <summary>
        /// 超时，触发异常
        /// </summary>
        /// <param name="connectionString"></param>
        /// <param name="sql"></param>
        /// <param name="millisecondsTimeout"></param>
        /// <returns></returns>
        [Call(typeof(ExecuteReaderReponse))]
        void ExecuteReader(string connectionString, string sql, int millisecondsTimeout, AsyncCBHandler asyncDelegate, object asyncContext);


        /// <summary>
        /// Execute the command and return the number of rows inserted/updated affected by
        //     it.
        /// </summary>
        /// <param name="connectionString"></param>
        /// <param name="commandText"></param>
        /// <param name="millisecondsTimeout"></param>
        /// <returns></returns>
        [Call(typeof(ExecuteNonQueryReponse))]
        void ExecuteNonQuery(string connectionString, string commandText, int millisecondsTimeout, AsyncCBHandler asyncDelegate, object asyncContext);


        /// <summary>
        /// Execute the command and return the first column of the first row of the resultset
        //     (if present), or null if no resultset was returned.
        /// </summary>
        /// <param name="connectionString"></param>
        /// <param name="commandText"></param>
        /// <param name="millisecondsTimeout"></param>
        /// <returns></returns>
        [Call(typeof(ExecuteScalarReponse))]
        void ExecuteScalar(string connectionString, string commandText, int millisecondsTimeout, AsyncCBHandler asyncDelegate, object asyncContext);
    }


    #region ExecuteReader

    public class ExecuteReaderReponse
    {
        public string ErrMsg;
        [JsonConverter(typeof(DataTableConverter))]
        public DataTable Ret;
    }
    #endregion


    #region ExecuteNonQuery
    public class ExecuteNonQueryReponse
    {
        public string ErrMsg;
        public int Ret;
    }
    #endregion

    #region ExecuteScalar

    public class ExecuteScalarReponse
    {
        public string ErrMsg;
        public object Ret;
    }
    #endregion
}
