﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SQLite;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using WebSocketSharp;
using WebSocketSharp.Server;
using WSCF;

namespace RemoteSQLite
{
    public class RemoteSQLiteServer
    {
        public WebSocketServer wssv;
        
        public string Addr { get; set; } = "0.0.0.0:20000";

        

        SQLiteRemote sQLiteRemote;
        SysTime sysTime;
        public RemoteSQLiteServer()
        {
            if (!Load())
            {
                Save();
            }
            if (string.IsNullOrEmpty(Addr)) {
                Addr = "0.0.0.0:20000";
            }
            Init();
        }
        public void Init()
        {
            sQLiteRemote = new SQLiteRemote();
            sysTime = new SysTime();
            wssv = new WebSocketServer($"ws://{Addr}/");
            wssv.AddWebSocketService<Reflect_Proxy>("/SQLiteRemote", (wsproxy) =>
            {
                wsproxy.Init(typeof(ISQLiteRemoteService), sQLiteRemote);
            });
            wssv.AddWebSocketService<Reflect_Proxy>("/SysTime", (wsproxy) =>
            {
                wsproxy.Init(typeof(ISysTimeService), sysTime);
            });
        }
        public void Start()
        {
            wssv.Start();
        }

        string file_path = "config.json";
        bool Save()
        {
            try
            {
                var p = new RemoteSQLiteServerConfigDBJson()
                {
                    addr = Addr
                };
                File.WriteAllText(file_path, JsonConvert.SerializeObject(p, Formatting.Indented));
                return true;
            }
            catch
            {
                //异常，没有json 编码失败

            }
            return false;
        }
        bool Load()
        {
            try
            {
                if (File.Exists(file_path))
                {
                    string json = File.ReadAllText(file_path);
                    var p = JsonConvert.DeserializeObject<RemoteSQLiteServerConfigDBJson>(json);
                    Addr = p.addr;
                    return true;
                }
            }
            catch { }
            {
                //异常，没有json 解码失败

            }
            return false;
        }
    }
    public class RemoteSQLiteServerConfigDBJson
    {
        public string addr;
    }




}
