﻿
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using WSCF;

namespace RemoteSQLite
{
    public class SQLiteRemoteServiceClient : Reflect_SeviceClient, ISQLiteRemoteService
    {
        protected override Type InterfaceType => typeof(ISQLiteRemoteService);

        public SQLiteRemoteServiceClient(string serverName, bool isByConnName, string addrOrConnName) : base(serverName, isByConnName, addrOrConnName)
        {

        }

        public void ExecuteReader(string connectionString, string commandText, int millisecondsTimeout, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(ExecuteReader), new { connectionString, commandText, millisecondsTimeout }, asyncDelegate, asyncContext);
        }

        public void ExecuteNonQuery(string connectionString, string commandText, int millisecondsTimeout, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(ExecuteNonQuery), new { connectionString, commandText, millisecondsTimeout }, asyncDelegate, asyncContext);
        }

        public void ExecuteScalar(string connectionString, string commandText, int millisecondsTimeout, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(ExecuteScalar), new { connectionString, commandText, millisecondsTimeout }, asyncDelegate, asyncContext);
        }
    }
}
